package appia.protocols.totalTemplate;

import appia.*;

public class TotalTemplLayer extends Layer {

    public TotalTemplLayer() {

	try {
	    // Declaracao dos eventos que o protocolo tem que receber
	    evRequire=new Class[1];
	    evRequire[0]=
		Class.forName("appia.protocols.group.events.GroupSendableEvent");
	    // Declaracao dos eventos que o protocolo quer receber.
	    // Tem que conter pelo menos os eventos contidos em evRequire.
	    evAccept=new Class[2];
	    evAccept[0]=evRequire[0];
	    evAccept[1]=Class.forName("appia.events.channel.ChannelInit");
	    
	    // Declaracao dos eventos que o protocolo vai criar.
	    // Nota: a declaracao de que se vai criar eventos nao implica
	    // que se queira recebe-los. Nesse caso devem tambem ser declarados
	    // no evAccept.
	    evProvide=new Class[0];
	}
	catch(ClassNotFoundException ex) {
	    System.err.println("Uma dos eventos na declaracao do protocolo "+
			       "TotalTemplate nao foi encontrado. Verifique "+
			       "se a variavel de ambiente CLASSPATH esta' "+
			       "bem definida e se nao houve erros de "+
			       "dactilografia.");
	}
    }

    public Session createSession() {
        return new TotalTemplSession(this);
    }

    public void channelDispose(Session session,Channel channel) {
    }
}
    

    
	
