package appia.protocols.totalTemplate;

import appia.*;
import appia.events.channel.ChannelInit;
import appia.protocols.group.events.*;

public class TotalTemplSession extends Session {
    
    Channel canal;

    public TotalTemplSession(Layer l) {
	super(l);
    }

    /* O nucleo do protocolo. Recebe os eventos e trata-os
       de forma a garantir a ordenacao. Por agora limita-se
       a mandar os eventos continuar o seu caminho pelo canal.
       Uma facilidade ja esta concretizada: quando recebe o
       evento a informar de que o canal foi inicializado,
       guarda a referencia para o canal para ser mais simples
       criar eventos.
       Provavelmente o resto do metodo handle sera' um conjunto
       de if(e instanceof xxx) em que consoante o tipo de evento
      e a direccao em que circula se chamara uma funcao adequada
    */

    public void handle(Event e) {
	try {
	    if(e instanceof ChannelInit) {
		canal=e.getChannel();
	    }
	    e.go();
	}
	catch(AppiaEventException ex) {
	    System.err.println("Excepcao no evento ao fazer go");
	}
    }

    public void boundSessions(Channel channel) {
    }
}
